﻿Imports System.Collections.ObjectModel


Class MainWindow

    Public Property Cluster As ObservableCollection(Of ClusterItem)
    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        Dim clusterList As New List(Of ClusterItem)
        For j = 0 To 200
            Dim pnl As New ClusterItem("name " & j.ToString)
            clusterList.Add(pnl)
        Next

        Cluster = New ObservableCollection(Of ClusterItem)(clusterList)
        Me.DataContext = Me
    End Sub

    Private _getSeletedClusterCommand As ICommand
    Public ReadOnly Property GetSeletedClusterCommand As ICommand
        Get
            If _getSeletedClusterCommand Is Nothing Then _
                _getSeletedClusterCommand = New RelayCommand(AddressOf GetSeletedClusterCommand_Execute)
            Return _getSeletedClusterCommand
        End Get
    End Property

    Private Sub GetSeletedClusterCommand_Execute(obj As Object)
        MessageBox.Show($"Es sind {Cluster.Where(Function(x) x.IsSelected).Count} Cluster selectiert. Hier die Aufstellung 
{Environment.NewLine}{String.Join(Environment.NewLine, Cluster.Where(Function(x) x.IsSelected).Select(Function(s) s.ClusterName).ToList)}")
    End Sub
End Class


Public Class ClusterItem
    Inherits ViewModelBase

    Public Sub New()
        Me.New("Unnamed")
    End Sub

    Public Sub New(clusterName As String)
        Me.ClusterName = clusterName
    End Sub

    Public ReadOnly Property ClusterName As String

    Private _isSelected As Boolean
    Public Property IsSelected As Boolean
        Get
            Return _isSelected
        End Get
        Set(ByVal Value As Boolean)
            _isSelected = Value
            RaisePropertyChanged()
        End Set
    End Property


    Private _selectCommand As ICommand
    Public ReadOnly Property SelectCommand As ICommand
        Get
            If _selectCommand Is Nothing Then _
                _selectCommand = New RelayCommand(AddressOf SelectCommand_Execute)
            Return _selectCommand
        End Get
    End Property

    Private Sub SelectCommand_Execute(obj As Object)
        IsSelected = Not IsSelected
    End Sub
End Class
